3 # Copyright (c) 2005, 2006 Junio C Hamano
8 git-am [options] <mbox>|<Maildir>...
9 git-am [options] --resolved
10 git-am [options] --skip
12 d,dotest= use <dir> and not .dotest
13 i,interactive run interactively
14 b,binary pass --allo-binary-replacement to git-apply
15 3,3way allow fall back on 3way merging if needed
16 s,signoff add a Signed-off-by line to the commit message
17 u,utf8 recode into utf8 (default)
18 k,keep pass -k flag to git-mailinfo
19 whitespace= pass it through git-apply
20 C= pass it through git-apply
21 p= pass it through git-apply
22 resolvemsg= override error message when patch failure occurs
23 r,resolved to be used after a patch failure
24 skip skip the current patch"
31 git var GIT_COMMITTER_IDENT >/dev/null || exit
34 echo "$1" >"$dotest/next"
38 stop_here_user_resolve () {
39 if [ -n "$resolvemsg" ]; then
40 printf '%s\n' "$resolvemsg"
43 cmdline=$(basename $0)
44 if test '' != "$interactive"
48 if test '' != "$threeway"
52 if test '.dotest' != "$dotest"
54 cmdline="$cmdline -d=$dotest"
56 echo "When you have resolved this problem run \"$cmdline --resolved\"."
57 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
63 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
64 "$dotest/patch" "$dotest/info"
65 echo "$next" >"$dotest/next"
71 echo "Cannot fall back to three-way merge."
76 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
78 rm -fr "$dotest"/patch-merge-*
79 mkdir "$dotest/patch-merge-tmp-dir"
81 # First see if the patch records the index info that we can use.
82 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
84 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
85 git write-tree >"$dotest/patch-merge-base+" ||
86 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
88 echo Using index info to reconstruct a base tree...
89 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
90 git apply $binary --cached <"$dotest/patch"
92 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
93 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
95 cannot_fallback "Did you hand edit your patch?
96 It does not apply to blobs recorded in its index."
99 test -f "$dotest/patch-merge-index" &&
100 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
101 orig_tree=$(cat "$dotest/patch-merge-base") &&
102 rm -fr "$dotest"/patch-merge-* || exit 1
104 echo Falling back to patching base and 3-way merge...
106 # This is not so wrong. Depending on which base we picked,
107 # orig_tree may be wildly different from ours, but his_tree
108 # has the same set of wildly different changes in parts the
109 # patch did not touch, so recursive ends up canceling them,
110 # saying that we reverted all those changes.
112 eval GITHEAD_$his_tree='"$SUBJECT"'
113 export GITHEAD_$his_tree
114 git-merge-recursive $orig_tree -- HEAD $his_tree || {
116 echo Failed to merge in the changes.
119 unset GITHEAD_$his_tree
123 git stripspace <"$1" | sed -e 1q
127 dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
143 utf8=t ;; # this is now default
155 shift; resolvemsg=$1 ;;
157 git_apply_opt="$git_apply_opt $1=$2"; shift ;;
159 git_apply_opt="$git_apply_opt $1$2"; shift ;;
168 # If the dotest directory exists, but we have finished applying all the
169 # patches in them, clear it out.
170 if test -d "$dotest" &&
171 last=$(cat "$dotest/last") &&
172 next=$(cat "$dotest/next") &&
174 test "$next" -gt "$last"
181 case "$#,$skip$resolved" in
183 # Explicit resume command and we do not have file, so
187 # No file input but without resume parameters; catch
188 # user error to feed us a patch from standard input
189 # when there is already .dotest. This is somewhat
190 # unreliable -- stdin could be /dev/null for example
191 # and the caller did not intend to feed us a patch but
192 # wanted to continue unattended.
199 die "previous dotest directory $dotest still exists but mbox given."
202 # Make sure we are not given --skip nor --resolved
203 test ",$skip,$resolved," = ,,, ||
204 die "Resolve operation not in progress, we are not resuming."
207 mkdir -p "$dotest" || exit
209 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
214 # -b, -s, -u, -k and --whitespace flags are kept for the
215 # resuming session after a patch failure.
216 # -3 and -i can and must be given when resuming.
217 echo "$binary" >"$dotest/binary"
218 echo " $ws" >"$dotest/whitespace"
219 echo "$sign" >"$dotest/sign"
220 echo "$utf8" >"$dotest/utf8"
221 echo "$keep" >"$dotest/keep"
222 echo 1 >"$dotest/next"
227 files=$(git diff-index --cached --name-only HEAD --) || exit
228 if [ "$files" ]; then
229 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
234 if test "$(cat "$dotest/binary")" = t
236 binary=--allow-binary-replacement
238 if test "$(cat "$dotest/utf8")" = t
244 if test "$(cat "$dotest/keep")" = t
248 ws=`cat "$dotest/whitespace"`
249 if test "$(cat "$dotest/sign")" = t
251 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
253 s/^/Signed-off-by: /'
259 last=`cat "$dotest/last"`
260 this=`cat "$dotest/next"`
264 this=`expr "$this" + 1`
268 if test "$this" -gt "$last"
275 while test "$this" -le "$last"
277 msgnum=`printf "%0${prec}d" $this`
278 next=`expr "$this" + 1`
279 test -f "$dotest/$msgnum" || {
285 # If we are not resuming, parse and extract the patch information
286 # into separate files:
287 # - info records the authorship and title
288 # - msg is the rest of commit log message
289 # - patch is the patch body.
291 # When we are resuming, these files are either already prepared
292 # by the user, or the user can tell us to do so by --resolved flag.
295 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
296 <"$dotest/$msgnum" >"$dotest/info" ||
299 # skip pine's internal folder data
300 grep '^Author: Mail System Internal Data$' \
301 <"$dotest"/info >/dev/null &&
304 test -s $dotest/patch || {
305 echo "Patch is empty. Was it split wrong?"
308 git stripspace < "$dotest/msg" > "$dotest/msg-clean"
312 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
313 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
314 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
316 if test -z "$GIT_AUTHOR_EMAIL"
318 echo "Patch does not have a valid e-mail address."
322 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
324 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
325 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
329 if test '' != "$SIGNOFF"
332 sed -ne '/^Signed-off-by: /p' \
333 "$dotest/msg-clean" |
337 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
338 test '' = "$LAST_SIGNED_OFF_BY" && echo
345 printf '%s\n' "$SUBJECT"
346 if test -s "$dotest/msg-clean"
349 cat "$dotest/msg-clean"
351 if test '' != "$ADD_SIGNOFF"
355 } >"$dotest/final-commit"
358 case "$resolved$interactive" in
360 # This is used only for interactive view option.
361 git diff-index -p --cached HEAD -- >"$dotest/patch"
367 if test "$interactive" = t
370 die "cannot be interactive without stdin connected to a terminal."
372 while test "$action" = again
374 echo "Commit Body is:"
375 echo "--------------------------"
376 cat "$dotest/final-commit"
377 echo "--------------------------"
378 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
382 [aA]*) action=yes interactive= ;;
383 [nN]*) action=skip ;;
384 [eE]*) git_editor "$dotest/final-commit"
385 SUBJECT=$(reread_subject "$dotest/final-commit")
388 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
396 if test $action = skip
402 if test -x "$GIT_DIR"/hooks/applypatch-msg
404 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
408 printf 'Applying %s\n' "$SUBJECT"
412 git apply $git_apply_opt $binary --index "$dotest/patch"
416 # Resolved means the user did all the hard work, and
417 # we do not have to do any patch application. Just
418 # trust what the user has in the index file and the
421 git diff-index --quiet --cached HEAD -- && {
422 echo "No changes - did you forget to use 'git add'?"
423 stop_here_user_resolve $this
425 unmerged=$(git ls-files -u)
426 if test -n "$unmerged"
428 echo "You still have unmerged paths in your index"
429 echo "did you forget to use 'git add'?"
430 stop_here_user_resolve $this
437 if test $apply_status = 1 && test "$threeway" = t
441 # Applying the patch to an earlier tree and merging the
442 # result may have produced the same tree as ours.
443 git diff-index --quiet --cached HEAD -- && {
444 echo No changes -- Patch already applied.
448 # clear apply_status -- we have successfully merged.
452 if test $apply_status != 0
454 echo Patch failed at $msgnum.
455 stop_here_user_resolve $this
458 if test -x "$GIT_DIR"/hooks/pre-applypatch
460 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
463 tree=$(git write-tree) &&
464 parent=$(git rev-parse --verify HEAD) &&
465 commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
466 git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
469 if test -x "$GIT_DIR"/hooks/post-applypatch
471 "$GIT_DIR"/hooks/post-applypatch